// Generated by https://github.com/foxglove/schemas

import { Color } from "./Color";
import { Point2 } from "./Point2";
import { PointsAnnotationType } from "./PointsAnnotationType";
import { Time } from "./Time";

/** An array of points on a 2D image */
export type PointsAnnotation = {
  /** Timestamp of annotation */
  timestamp: Time;

  /** Type of points annotation to draw */
  type: PointsAnnotationType;

  /** Points in 2D image coordinates (pixels) */
  points: Point2[];

  /** Outline color */
  outline_color: Color;

  /** Per-point colors, if `type` is `POINTS`, or per-segment stroke colors, if `type` is `LINE_LIST`. */
  outline_colors: Color[];

  /** Fill color */
  fill_color: Color;

  /** Stroke thickness in pixels */
  thickness: number;
};
