// Generated by https://github.com/foxglove/schemas

import { ArrowPrimitive } from "./ArrowPrimitive";
import { CubePrimitive } from "./CubePrimitive";
import { CylinderPrimitive } from "./CylinderPrimitive";
import { Duration } from "./Duration";
import { KeyValuePair } from "./KeyValuePair";
import { LinePrimitive } from "./LinePrimitive";
import { ModelPrimitive } from "./ModelPrimitive";
import { SpherePrimitive } from "./SpherePrimitive";
import { TextPrimitive } from "./TextPrimitive";
import { Time } from "./Time";
import { TriangleListPrimitive } from "./TriangleListPrimitive";

/** A visual element in a 3D scene. An entity may be composed of multiple primitives which all share the same frame of reference. */
export type SceneEntity = {
  /** Timestamp of the entity */
  timestamp: Time;

  /** Frame of reference */
  frame_id: string;

  /** Identifier for the entity. A entity will replace any prior entity on the same topic with the same `id`. */
  id: string;

  /** Length of time (relative to `timestamp`) after which the entity should be automatically removed. Zero value indicates the entity should remain visible until it is replaced or deleted. */
  lifetime: Duration;

  /** Whether the entity should keep its location in the fixed frame (false) or follow the frame specified in `frame_id` as it moves relative to the fixed frame (true) */
  frame_locked: boolean;

  /** Additional user-provided metadata associated with the entity. Keys must be unique. */
  metadata: KeyValuePair[];

  /** Arrow primitives */
  arrows: ArrowPrimitive[];

  /** Cube primitives */
  cubes: CubePrimitive[];

  /** Sphere primitives */
  spheres: SpherePrimitive[];

  /** Cylinder primitives */
  cylinders: CylinderPrimitive[];

  /** Line primitives */
  lines: LinePrimitive[];

  /** Triangle list primitives */
  triangles: TriangleListPrimitive[];

  /** Text primitives */
  texts: TextPrimitive[];

  /** Model primitives */
  models: ModelPrimitive[];
};
